'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Tag = require('./Tag');

var _Tag2 = _interopRequireDefault(_Tag);

var _hoc = require('./hoc');

var _hoc2 = _interopRequireDefault(_hoc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createComponent = function createComponent(config) {
  var components = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var tag = config.tag,
      props = config.props,
      style = config.style,
      _config$propTypes = config.propTypes,
      propTypes = _config$propTypes === undefined ? {} : _config$propTypes,
      _config$defaultProps = config.defaultProps,
      defaultProps = _config$defaultProps === undefined ? {} : _config$defaultProps;

  if (!config || !tag || !style) return null;

  var _tag = components[tag] || tag;

  var Base = (0, _hoc2.default)((0, _Tag2.default)(_tag));
  var Component = (0, _styledComponents2.default)(Base).attrs(props)([], style);

  Component.propTypes = propTypes;
  Component.defaultProps = defaultProps;

  return Component;
};

exports.default = createComponent;